#include <boost/property_tree/ptree.hpp>
#include <boost/property_tree/ini_parser.hpp>

#include "config.hpp"
#include "executable.hpp"

double conf_aggr_ts;
double conf_aggr_tav;
bool conf_debug_dump_flight_data;
bool conf_debug_dump_adc_raw;

static class _config_
{
public:
	_config_()
	{
		boost::property_tree::ptree pt;
		boost::filesystem::path path = get_executable_directory();
		path /= "config.ini";
		boost::property_tree::ini_parser::read_ini(path.string(), pt);
		conf_aggr_ts = pt.get<double>("aggregation.ts");
		conf_aggr_tav = pt.get<double>("aggregation.tav");
		conf_debug_dump_flight_data = pt.get<bool>("debug.dump_flight_data");
		conf_debug_dump_adc_raw = pt.get<bool>("debug.dump_adc_raw");
	}
} _config_obj_;
